/* netguard/tcpguard.c */
/* Intercepts all incoming TCP connection attemps and sends them to syslog.
 * For bug reports and comments, please mail lizard8@iname.com !!!
 *
 * THERE IS ABSOLUTELY NO WARRANTY PROVIDED FOR THIS PROGRAM !!!
 * YOU MAY INCLUDE IT IN YOUR PROGRAMS, MODIFY IT, RE-DISTRIBUTE IT, ...
 * WHATEVER !... JUST MAKE SURE YOU GIVE ME THE CREDITS FOR MY WORK.
 *
 * This version (0.0.3) kills all attempted connections to localhost:80 !
 * (THIS IS JUST A TEST! MODIFY IT FOR YOUR OWN PURPOSES !)
 * The kill is done partially... only one of the peers gets the RST packet...
 * (_YOU_ MAKE IT FULLY WORK !..;) ) - The connection still dies though !  
 */

#include <libnet.h>
#include <syslog.h>
// Biggest list of includes you've ever seen, eh?!.. ;)

struct ippkt {
 struct iphdr ip;
 struct tcphdr tcp;
 char buffer[5000];
} pkt;

void
main() {
 int s, lns;
 struct in_addr src_addr;
 u_long src_ip=0, dst_ip=0, ack, prev_seq=0;
 u_char *buff;
 u_int sport, dport;
 
 openlog("tcpguard", 0, LOG_DAEMON);

#ifndef NO_EUID_CHECK
 if(geteuid()!=0) { 
  syslog(LOG_INFO, "launched by normal user (uid %d).\n", geteuid());
  printf("This program uses raw sockets. On most systems, that requires root.\n");
  printf("If you know that your systems allows usage of raw sockets by normal\n");
  printf("users, re-compile the program with -DNO_EUID_CHECK.\n");
  _exit(1);
 } 
#endif

 if((s=socket(AF_INET, SOCK_RAW, IPPROTO_TCP))==-1) {
  perror("socket()"); _exit(2); }
 
 if(fork()!=0) _exit(0);
 setsid();

 syslog(LOG_INFO, "TCPguard Copyright (c) 1999 Monk.");
 syslog(LOG_INFO, "launched with pid %d.\n", getpid());
 
 while(1) {
  read(s, (struct ippkt *)&pkt, 5000);

 if((pkt.tcp.th_flags&TH_SYN)&&(!(pkt.tcp.th_flags&TH_ACK))) {
   /* Normal logging of SYN&!ACK packets... */
   src_addr.s_addr=0;
   src_addr.s_addr=pkt.ip.saddr;
   syslog(LOG_INFO, "TCP connection attempt from %s:%d to port %d.", inet_ntoa(src_addr), ntohs(pkt.tcp.th_sport), ntohs(pkt.tcp.th_dport));

   /* Queso sends all its packets with a constant window size ... */
   if(pkt.tcp.th_win==htons(4660))
    syslog(LOG_INFO, "A packet probably sent by QUESO was received !\n");

   /* The following kills all TCP connections to port 80 ! */
   /* WARNING: This part does not make any checks !!! */
   if(ntohs(pkt.tcp.th_dport)==80) {
    sport=ntohs(pkt.tcp.th_sport);
    dport=ntohs(pkt.tcp.th_dport);
    src_ip=pkt.ip.daddr;
    dst_ip=pkt.ip.saddr;
    ack=ntohl(pkt.tcp.th_seq)+1;
    buff=malloc(TCP_H+IP_H);
    bzero(buff, TCP_H+IP_H);
    build_ip(TCP_H, IPTOS_LOWDELAY | IPTOS_THROUGHPUT, 242, 0, 64, IPPROTO_TCP, src_ip, dst_ip, NULL, 0, buff);
    build_tcp(sport, dport, ack, ack, TH_RST, 4096, 0, NULL, 0, buff+IP_H);
    do_checksum(buff, IPPROTO_TCP, TCP_H);
    lns=open_raw_sock(IPPROTO_RAW);
    syslog(LOG_INFO, "KILLING CONNECTION !!!");
    write_ip(lns, buff, IP_H+TCP_H);
    close(lns);
   }

   /* The following is a better checker for SYN flooding than the one
    * in 0.0.2 .  Check out the README for more info.
    */
   if(pkt.tcp.th_seq!=prev_seq) prev_seq=pkt.tcp.th_seq; else {
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !");
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !!");
    syslog(LOG_INFO, "YOU ARE BEING SYN-FLOODED !!!");
    syslog(LOG_INFO, "TCPguard is dying...");
    _exit(3);
   }
  }
 }
}

